//-------------------------------------------------------------
//  Daily_Open
//-------------------------------------------------------------
// Keywords: daily trading
// Built with Etasoft Forex Generator

#property copyright "Copyright  2015, IAmRetep"

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
 int OrderType9 = OP_BUY;
 int OrderId9 = 42;
 int OrderId14 = 42;
extern int TrailingStop14 = 60;
extern int NewTakeProfit14 = 50;
extern int TrailingGap14 = 30;
 int OrderId13 = 42;
extern int Stoploss13 = 110;
extern int Takeprofit12 = 110;
 int OrderType8 = OP_SELL;
 int OrderId8 = 43;
 int OrderId17 = 43;
extern int TrailingStop17 = 50;
extern int NewTakeProfit17 = 50;
extern int TrailingGap17 = 30;
extern int Takeprofit15 = 100;
 int OrderId16 = 43;
extern int Stoploss16 = 110;
extern double MaxSpread50 = 8;
extern double SellLots33 = 1;
 int SellOrderId33 = 43;
 int OrderType32 = OP_BUY;
 int OrderId32 = 42;
extern double BuyLots45 = 1;
 int BuyOrderId45 = 42;
 int OrderType35 = OP_SELL;
 int OrderId35 = 43;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;

bool eb_use_buy    = true;
bool eb_use_sell   = true;

 string separator1    = "--Hours Allowed Long--";
 string es_hours_long  = "00 - 23";
 string separator2    = "--Hours Allowed Short--";
 string es_hours_short = "00 - 23";
 int  Diff_2_GMT = 0;
 int gia_hours_long[];
 int gia_hours_short[];

datetime BarTime25 = 0;
datetime BarTime35 = 0;

extern bool TradeLong = True;
extern bool TradeShort = True;
extern bool TrailingYes = True;
extern bool IsNewDay = False;
extern int sl= 100;
extern int tp= 100;
extern int DiffHighLow= 16;
string vVersion;
datetime BarTime39 = 0;
datetime BarTime44 = 0;


int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    
    
    
    
    cut_hours( es_hours_long, gia_hours_long);
    cut_hours( es_hours_short, gia_hours_short);
    
    IsNewDay = False;
    
    
    
    
    Comment("");    // clear the chart
    return (0);
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick51();
    return (0);
}

void OnEveryTick51()
{
    PipValue = 1;
    if (NDigits == 3 || NDigits == 5) PipValue = 10;
    
    CustomIf53();
    CustomCode71();
    CustomCode73();
    
}

void cut_hours( string ps_hourList, int& pia_array[] )
{
    string sa_pos[], s_string;
    int i, i_pos_of_until, i_Index = 0 , i_Untergrenze, i_Obergrenze;
    string s_sep  = ";";
    ushort us_sep = StringGetCharacter( s_sep, 0 );
    ArrayResize( pia_array, 24 );
    
    int k = StringSplit( ps_hourList, us_sep, sa_pos );
    
    if ( k > 0 )
    {
        for ( i = 0; i < k; i++)
        {
            i_pos_of_until = StringFind( sa_pos[i], "-" );
            
            if ( i_pos_of_until > 0 )
            {
                s_string = StringSubstr(sa_pos[i], 0, i_pos_of_until );
                //Print("Untergrenze: " + s_string);
                i_Untergrenze = StringToInteger( s_string );
                s_string = StringSubstr(sa_pos[i], i_pos_of_until + 1 );
                //Print("Obergrenze: " + s_string);
                i_Obergrenze = StringToInteger( s_string );
                
                for ( int j = i_Untergrenze; j <= i_Obergrenze; j++)
                {
                    pia_array[i_Index] = j;
                    i_Index++;
                }
            }
            else
            {
                pia_array[i_Index] = StringToInteger( sa_pos[i] );
                i_Index++;
            }
        }
    }
    else
    {
        for ( i = 0; i < 24; i++)
        {
            pia_array[i_Index] = i;
            i_Index++;
        }
    }
    
    ArrayResize( pia_array, i_Index );
    
    /*
    Print("");
    Print("Stundenarray mit GMT-Korrektur");
    */
    
    for ( i = 0; i < ArraySize(pia_array); i++ )
    {
        pia_array[i] = pia_array[i] + Diff_2_GMT;
        //Print(pia_array[i]);
    }
}

bool isTradingHour( int& pi_trading_hours[] )
{
    int hour = TimeHour(TimeLocal());
    
    for ( int i = 0; i < ArraySize(pi_trading_hours); i++ )
    if ( pi_trading_hours[i] == hour )
    return (true);
    
    return (false);
}

void CustomIf53()
{
    if (TrailingYes)
    {
        IfOrderExists9();
        IfOrderExists8();
        
    }
}

void IfOrderExists9()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType9 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId9)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        TrailingStop14();
        VirtualStoploss13();
        VirtualTakeprofit12();
        
    }
}

void TrailingStop14()
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId14)
        {
            double takeprofit = OrderTakeProfit();
            
            if (OrderType() == OP_BUY && Ask - OrderOpenPrice() > TrailingStop14*PipValue*Point)
            {
                if (OrderStopLoss() < Ask-(TrailingStop14+TrailingGap14)*PipValue*Point)
                {
                    if (NewTakeProfit14 != 0) takeprofit = Ask+(NewTakeProfit14 + TrailingStop14)*PipValue*Point;
                    bool ret1 = OrderModify(OrderTicket(), OrderOpenPrice(), Ask-TrailingStop14*PipValue*Point, takeprofit, OrderExpiration(), Yellow);
                    if (ret1 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Bid > TrailingStop14*PipValue*Point)
            {
                if (OrderStopLoss() > Bid+(TrailingStop14+TrailingGap14)*PipValue*Point)
                {
                    if (NewTakeProfit14 != 0) takeprofit = Bid-(NewTakeProfit14 + TrailingStop14)*PipValue*Point;
                    bool ret2 = OrderModify(OrderTicket(), OrderOpenPrice(), Bid+TrailingStop14*PipValue*Point, takeprofit, OrderExpiration(), Yellow);
                    if (ret2 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}

void VirtualStoploss13()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[90][2];
    for (int i = 0; i < orderstotal; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol() || OrderMagicNumber() != OrderId13)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId13)
            {
                if ((OrderType() == OP_SELL && Bid - OrderOpenPrice() > Stoploss13*PipValue*Point) ||
                (OrderType() == OP_BUY && OrderOpenPrice() - Ask > Stoploss13*PipValue*Point))
                {
                    bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
                    int error = GetLastError();
                    if (ret == false && error > 0)
                    Print("OrderClose() error - ", ErrorDescription(error));
                }
                
            }
            
        }
    }
    
}

void VirtualTakeprofit12()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[90][2];
    for (int i = 0; i < orderstotal; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol() || OrderMagicNumber() != 42)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == 42)
            {
                if ((OrderType() == OP_SELL && OrderOpenPrice() - Bid > Takeprofit12*PipValue*Point) ||
                (OrderType() == OP_BUY && Ask - OrderOpenPrice() > Takeprofit12*PipValue*Point))
                {
                    bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 3, Green);
                    int error = GetLastError();
                    if (ret == false && error > 0)
                    Print("OrderClose() error - ", ErrorDescription(error));
                }
                
            }
            
        }
    }
    
}

void IfOrderExists8()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType8 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId8)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        TrailingStop17();
        VirtualTakeprofit15();
        VirtualStoploss16();
        
    }
}

void TrailingStop17()
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId17)
        {
            double takeprofit = OrderTakeProfit();
            
            if (OrderType() == OP_BUY && Ask - OrderOpenPrice() > TrailingStop17*PipValue*Point)
            {
                if (OrderStopLoss() < Ask-(TrailingStop17+TrailingGap17)*PipValue*Point)
                {
                    if (NewTakeProfit17 != 0) takeprofit = Ask+(NewTakeProfit17 + TrailingStop17)*PipValue*Point;
                    bool ret1 = OrderModify(OrderTicket(), OrderOpenPrice(), Ask-TrailingStop17*PipValue*Point, takeprofit, OrderExpiration(), Yellow);
                    if (ret1 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Bid > TrailingStop17*PipValue*Point)
            {
                if (OrderStopLoss() > Bid+(TrailingStop17+TrailingGap17)*PipValue*Point)
                {
                    if (NewTakeProfit17 != 0) takeprofit = Bid-(NewTakeProfit17 + TrailingStop17)*PipValue*Point;
                    bool ret2 = OrderModify(OrderTicket(), OrderOpenPrice(), Bid+TrailingStop17*PipValue*Point, takeprofit, OrderExpiration(), Yellow);
                    if (ret2 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}

void VirtualTakeprofit15()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[90][2];
    for (int i = 0; i < orderstotal; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol() || OrderMagicNumber() != 43)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == 43)
            {
                if ((OrderType() == OP_SELL && OrderOpenPrice() - Bid > Takeprofit15*PipValue*Point) ||
                (OrderType() == OP_BUY && Ask - OrderOpenPrice() > Takeprofit15*PipValue*Point))
                {
                    bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 3, Green);
                    int error = GetLastError();
                    if (ret == false && error > 0)
                    Print("OrderClose() error - ", ErrorDescription(error));
                }
                
            }
            
        }
    }
    
}

void VirtualStoploss16()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[90][2];
    for (int i = 0; i < orderstotal; i++)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol() || OrderMagicNumber() != OrderId16)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId16)
            {
                if ((OrderType() == OP_SELL && Bid - OrderOpenPrice() > Stoploss16*PipValue*Point) ||
                (OrderType() == OP_BUY && OrderOpenPrice() - Ask > Stoploss16*PipValue*Point))
                {
                    bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
                    int error = GetLastError();
                    if (ret == false && error > 0)
                    Print("OrderClose() error - ", ErrorDescription(error));
                }
                
            }
            
        }
    }
    
}

void CustomCode71()
{
    
    CustomCode72();
    
}

void CustomCode72()
{
    
    WeekdayFilter49();
    
}

void WeekdayFilter49()
{
    if ((true && DayOfWeek() == 1) || (true && DayOfWeek() == 2) || (true && DayOfWeek() == 3) ||
    (true && DayOfWeek() == 4) || (true && DayOfWeek() == 5) || (false && DayOfWeek() == 6) || (false && DayOfWeek() == 0))
    {
        SpreadFilter50();
        
    }
}

void SpreadFilter50()
{
    if ((Ask-Bid) / Point / PipValue < MaxSpread50)
    {
        WeekdayFilter70();
        WeekdayFilter69();
        
    }
}

void WeekdayFilter70()
{
    if ((true && DayOfWeek() == 1) || (true && DayOfWeek() == 2) || (true && DayOfWeek() == 3) ||
    (true && DayOfWeek() == 4) || (true && DayOfWeek() == 5) || (false && DayOfWeek() == 6) || (true && DayOfWeek() == 0))
    {
        CustomIf67();
        
    }
}

void CustomIf67()
{
    if (isTradingHour(gia_hours_short))
    {
        CustomIf66();
        
    }
}

void CustomIf66()
{
    if (TradeShort)
    {
        CustomIf75();
        
    }
}

void CustomIf75()
{
    if (IsNewDay)
    {
        TechnicalAnalysis40();
        
    }
}

void TechnicalAnalysis40()
{
    if (Open[1] > Close[1])
    {
        TechnicalAnalysis41();
        
    }
}

void TechnicalAnalysis41()
{
    if (Bid < Open[0] - DiffHighLow* PipValue * Point)
    {
        OncePerBar39();
        
    }
}

void OncePerBar39()
{
    
    if (BarTime39 < Time[0])
    {
        // we have a new bar opened
        BarTime39 = Time[0]; // keep the new bar open time
        IfOrderDoesNotExist34();
        
    }
}

void IfOrderDoesNotExist34()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 43)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        SellOrderFlex33();
        IfOrderExists32();
        
    }
}

void SellOrderFlex33()
{
    double SL = NormalizeDouble(Bid + sl* PipValue * Point, NDigits);
    if (Bid + sl* PipValue * Point == 0) SL = 0;
    double TP = NormalizeDouble(Bid - tp* PipValue * Point, NDigits);
    if (Bid - tp* PipValue * Point == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_SELL, SellLots33, Bid, 4, 0, 0, "CCI_SMI", SellOrderId33, 0, Red);
    else
    ticket = OrderSend(Symbol(), OP_SELL, SellLots33, Bid, 4, SL, TP, "CCI_SMI", SellOrderId33, 0, Red);
    if (ticket > -1)
    {
        if (true)
        {
            bool sel = OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Red);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void IfOrderExists32()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType32 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId32)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        CloseOrder38();
        
    }
}

void CloseOrder38()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[90][2];
    for (int i = 0; i < orderstotal; i++)
    {
        bool sel = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_BUY || OrderSymbol() != Symbol() || OrderMagicNumber() != 42)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    
}

void WeekdayFilter69()
{
    if ((true && DayOfWeek() == 1) || (true && DayOfWeek() == 2) || (true && DayOfWeek() == 3) ||
    (true && DayOfWeek() == 4) || (true && DayOfWeek() == 5) || (false && DayOfWeek() == 6) || (true && DayOfWeek() == 0))
    {
        CustomIf68();
        
    }
}

void CustomIf68()
{
    if (isTradingHour(gia_hours_long))
    {
        CustomIf58();
        
    }
}

void CustomIf58()
{
    if (TradeLong)
    {
        CustomIf74();
        
    }
}

void CustomIf74()
{
    if (IsNewDay)
    {
        TechnicalAnalysis43();
        
    }
}

void TechnicalAnalysis43()
{
    if (Open[1] < Close[1])
    {
        TechnicalAnalysis42();
        
    }
}

void TechnicalAnalysis42()
{
    if (Ask > Open[0] + DiffHighLow* PipValue * Point)
    {
        OncePerBar44();
        
    }
}

void OncePerBar44()
{
    
    if (BarTime44 < Time[0])
    {
        // we have a new bar opened
        BarTime44 = Time[0]; // keep the new bar open time
        IfOrderDoesNotExist37();
        
    }
}

void IfOrderDoesNotExist37()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 42)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        BuyOrderFlex45();
        IfOrderExists35();
        
    }
}

void BuyOrderFlex45()
{
    double SL = NormalizeDouble(Ask - sl* PipValue * Point, NDigits);
    if (Ask - sl* PipValue * Point == 0) SL = 0;
    double TP = NormalizeDouble(Ask + tp* PipValue * Point, NDigits);
    if (Ask + tp* PipValue * Point == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots45, Ask, 4, 0, 0, "CCI_SMI", BuyOrderId45, 0, Blue);
    else
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots45, Ask, 4, SL, TP, "CCI_SMI", BuyOrderId45, 0, Blue);
    if (ticket > -1)
    {
        if (true)
        {
            bool sel = OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Blue);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void IfOrderExists35()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType35 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId35)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        CloseOrder36();
        
    }
}

void CloseOrder36()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[90][2];
    for (int i = 0; i < orderstotal; i++)
    {
        bool sel = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != 43)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    
}

void CustomCode73()
{
    if(Hour()>=0 && Hour()<1)
    {
        if (IsNewDay == false)
        {
            IsNewDay=true;
        }
    }
    
    
}



int deinit()
{
    if (false) ObjectsDeleteAll();
    
    
    
    
    
    
    
    
    
    
    
    
    return (0);
}

